/***********************************************
 *  RC$B%5!<%\$r;H$C$?1@Bf@)8f%W%m%0%i%`(B
 *$B!!%8%g%$%9%F%#%C%/$G1@Bf$NJ}8~@)8f(B
 *$B!!%9%$%C%A(BSW
************************************************/
#include    <htc.h>
#include    <stdio.h>
#include    "lcd_lib.h"
/***** $B%3%s%U%#%.%e%l!<%7%g%s$N@_Dj(B *********/
__CONFIG(FOSC_INTOSC & WDTE_OFF & PWRTE_ON & MCLRE_ON & CP_OFF
	& BOREN_ON & CLKOUTEN_OFF & IESO_OFF & FCMEN_OFF);
__CONFIG(WRT_OFF & STVREN_OFF & LVP_OFF);

/** $B%0%m!<%P%kDj?tJQ?tDj5A(B **/
unsigned int HWidth, VWidth, DFlag, Mode, i;
unsigned int Interval, AutoFlag, AutoInt, Level, NewLvl;
unsigned int PeakL, PeakH, PeakV;

/** $B4X?t%W%m%H%?%$%T%s%0(B **/
unsigned int ADConv(unsigned char ch);
void Display(void);
void CLCInit(void);
void Vertical(void);
void Horizontal(void);

/******** $B%a%$%s4X?t(B  ************/
void main(void) {
    /** $B%/%m%C%/@_Dj(B **/
    OSCCON = 0x73;                      // $BFbB"(B8MHz
    /** $BF~=PNO%]!<%H$N@_Dj(B ***/
    ANSELA = 0xE0;                      // AN5,AN6,AN7$B$N$_%"%J%m%0(B
    ANSELB = 0x00;                      // $B%G%8%?%k(B    
    TRISA = 0x3B;                       // RA0,1,3,4,5$B$N$_F~NO@_Dj(B
    TRISB = 0x00;                       // $B$9$Y$F=PNO(B
    TRISC = 0x2E;                       // RC1,2,3,5$B$N$_F~NO(B
    /** $B%W%k%"%C%W%$%M!<%V%k(B **/
    WPUA = 0x30;                        // RA4,5 pullup   
    /* $B%?%$%^(B0$B$N@_Dj!!(B20.04msec$B<~4|(B */
    OPTION_REG = 0x07;                  // Int. 1/256, $B%W%k%"%C%WM-8z2=(B
    TMR0 = 99;                          // 20msec         
    /* PWM1,4$B$N=i4|@_Dj(B 2.048msec$B<~4|(B*/
    /* Duty$BCM@_DjHO0O(B  450 to 1023 (0.9ms to 2.05ms width) */
    HWidth = 750;                       // $B=i4|CM(B1.5msec
    VWidth = 750;
    PWM1CON = 0x80;                     // PWM1$B%*%s(B Output$BL58z(B
    PWM1DCH = HWidth >> 2;
    PWM1DCL = HWidth << 6;
    PWM4CON = 0x80;                     // PWM4$B%*%s(B Output$BL58z(B
    PWM4DCH = VWidth >> 2;
    PWM4DCL = VWidth << 6;
    /* $B%?%$%^#2$N@_Dj(B */
    T2CON = 0x06;                       // 1/16  2MHz/16/256 = 2.048msec$B<~4|(B
    PR2 = 0xFF;                         // 10bit$BJ,2rG=(B
    /* ADC$B=i4|@_Dj(B */
    ADCON0 = 0x00;
    ADCON1 = 0xA0;                      // Right, Fosc/32, VDD-VSS
    ADCON2 = 0x00;                      // Manual
    ADCON0bits.ADON = 1;                // Enable ADC
    /** CLC$B$N=i4|@_Dj(B  **/
    CLCInit();
     /* $BJQ?t%j%;%C%H(B */
    Interval = 5;                       // 0.1sec
    AutoInt = 300;                      // $B<+F0<~4|(B 30sec
    DFlag = 1;                          // $BI=<(%U%i%0%;%C%H(B
    Mode = 0;                           // $BF0:n%b!<%I=i4|2=(B Manual
    AutoFlag = 0;                       // $B<+F0%b!<%I%U%i%0(B
    /* LCD$B=i4|2=(B */
    lcd_init();                         // $B=i4|2=(B
    printf("** Start App! **");         // $B3+;O%a%C%;!<%8I=<((B
    /* $B3d$j9~$_5v2D(B */
    TMR0IE = 1;                         // $B%?%$%^(B0$B3d$j9~$_5v2D(B
    PEIE = 1;                           // $B<~JU5v2D(B
    GIE = 1;                            // $B%0%m!<%P%k5v2D(B
    
    /************ $B%a%$%s%k!<%W(B  **********/
    while (1) {
        if(Mode == 0){                              // $B%^%K%e%"%k%b!<%I$N>l9g(B
            /* Joy X input */
            HWidth = ADConv(6)+225;                 // AN6$BJQ49!!Cf1{CMJd@5(B
            if(HWidth < 450)
                HWidth = 450;                       // $B:G>.B&@)8B(B   $BLs(B0.9msec
            else if(HWidth > 1023)
                HWidth = 1023;                      // $B:GBgB&@)8B!!Ls(B2.05msec
             /* Joy Y input */
            VWidth = ADConv(5)+175;                 // AN5$BJQ49!!Cf1{CMJd@5(B
            if(VWidth < 450)
                VWidth = 450;                       // $B:G>.B&@)8B!!Ls(B0.9msec
            else if(VWidth > 1023)
                VWidth = 1023;                      // $B:GBgB&@)8B!!Ls(B2.05msec
            /* $B%G%e!<%F%#$K%;%C%H(B */
            PWM1DCH = HWidth >> 2;                  // PWM1
            PWM1DCL = HWidth << 6;
            PWM4DCH = VWidth >> 2;                  // PWM4
            PWM4DCL = VWidth << 6;
            Level = ADConv(7);                      // $B%l%Y%k=i4|CM<hF@(B
            PeakL = Level;                          // $B:GBgCM=i4|CM%;%C%H(B
        }
        else{                                       // $B<+F0%b!<%I$N>l9g(B
           if(AutoFlag){                            // $B<+F0%b!<%I3+;O%*%s$+!)(B
                AutoFlag = 0;                       // $B<+F0%b!<%I%U%i%0%/%j%"(B
                 for(i=0; i<5; i++){
                    Horizontal();                   // $B?eJ?J}8~=gJ}8~C5:w(B 
                    Vertical();                     // $B?bD>J}8~=gJ}8~C5:w(B
                    /** $B:G=*%T!<%/0LCV$X0\F0(B ***/
                    HWidth = PeakH;                 // $B%T!<%/0LCVI|85(B
                    VWidth = PeakV;
                    PeakL = ADConv(7);              // $B%l%Y%k:FB,Dj(B
                    PWM1DCH = PeakH >> 2;           // PWM1$B@_Dj(B
                    PWM1DCL = PeakH << 6;
                    PWM4DCH = PeakV >> 2;           // PWM4$B@_Dj(B
                    PWM4DCL = PeakV << 6;
                }
            }
        }
        /* $B0LCV:BI8I=<((B */
        if(DFlag){                                  // $BI=<(%U%i%0%*%s$+!)(B
            Display();                              // $B0LCVI=<(<B9T(B
            DFlag = 0;                              // $BI=<(%U%i%0%/%j%"(B
            Interval = 5;                           // 10sec
             /** $B%9%$%C%AF~NO%A%'%C%/(B **/
            if(PORTAbits.RA5 == 0){                 // SW2$B%A%'%C%/(B
                if(Mode == 0){                      // $B<jF0%b!<%ICf$N>l9g(B
                    Mode = 1;                       // $B<+F0%b!<%I$K$9$k(B
                    AutoFlag = 1;                   // $B<+F0%b!<%I@_Dj(B
                    lcd_cmd(0x80);
                    printf("Auto Mode       ");     // $BI=<((B
                }
                else{                               // $B<+F0%b!<%ICf$N>l9g(B
                    Mode = 0;                       // $B<jF0%b!<%I$K$9$k(B
                    lcd_cmd(0x80);                     
                    printf("Manual Mode     ");     // $BI=<((B
                }
                while(PORTAbits.RA5 == 0);          // $B%A%c%C%?2sHr(B
            }
        }

    }
}
/*************************************
 *  $B?eJ?J}8~:GBgCMC5:w(B
 *************************************/
void Horizontal(void){
    /* $B?eJ?J}8~=gJ}8~C5:w(B */
    do{
        HWidth += 10;               // $BA}$7J,(B
        if(HWidth > 1023)           // $B:GBgCM@)8B(B
            HWidth = 1023;           // $BCf1{$XI|5"(B
        PWM1DCH = HWidth >> 2;      // PWM1$B@_Dj(B
        PWM1DCL = HWidth << 6;                     
        __delay_ms(100);
        Level = NewLvl;             // $B2a5nCM99?7(B
        Display();                  // $B:BI8CMI=<((B
        NewLvl = ADConv(7);         // $B?7%l%Y%kB,Dj(B
        if(NewLvl > PeakL+20){       // $B:GBgCMHf3S(B
            PeakL = NewLvl;         // $B:GBgCM99?7(B
            PeakH = HWidth;
            PeakV = VWidth;
        }                        
    }while(Level < NewLvl);         // $B%T!<%/99?77QB3(B
    /** $B?eJ?J}8~5UJ}8~C5:w(B **/
    do{
        HWidth -= 10;               // $BA}$7J,(B
        if(HWidth < 450)            // $B:G>.CM@)8B(B
            HWidth = 450;
        PWM1DCH = HWidth >> 2;      // PWM1$B@_Dj(B
        PWM1DCL = HWidth << 6;                     
        __delay_ms(100);
        Level = NewLvl;             // $B2a5nCM99?7(B
        Display();                         
        NewLvl = ADConv(7);         // $B?7%l%Y%kB,Dj(B
          if(NewLvl > PeakL+20){     // $B:GBgCMHf3S(B
            PeakL = NewLvl;         // $B:GBgCM99?7(B
            PeakH = HWidth;
            PeakV = VWidth;
        }
    }while(Level < NewLvl);         // $B%T!<%/99?77QB3(B
}
/*************************************
 *  $B?bD>J}8~:GBgCMC5:w(B
 *************************************/
void Vertical(void){
    /** $B?bD>J}8~=gJ}8~C5:w(B **/
    do{
        VWidth += 10;               // $BA}$7J,(B
        if(VWidth > 1023)           // $B:GBgCM@)8B(B
            VWidth = 1023;
        PWM4DCH = VWidth >> 2;      // PWM4$B@_Dj(B
        PWM4DCL = VWidth << 6;
        __delay_ms(100);
        Level = NewLvl;             // $B2a5nCM99?7(B
        Display();                  // $B:BI8I=<((B
        NewLvl = ADConv(7);         // $B?7%l%Y%kB,Dj(B
        if(NewLvl > PeakL){         // $B:GBgCMHf3S(B
            PeakL = NewLvl;         // $B:GBgCM99?7(B
            PeakH = HWidth;
            PeakV = VWidth;
        }
    }while(Level < NewLvl);         // $B%T!<%/99?77QB3(B
    /** $B?bD>J}8~5UJ}8~C5:w(B **/
    do{
        VWidth -= 10;               // $BA}$7J,(B
        if(VWidth < 450)            // $B:G>.CM@)8B(B
            VWidth = 450;
        PWM4DCH = VWidth >> 2;      // PWM4$B@_Dj(B
        PWM4DCL = VWidth << 6;
        __delay_ms(100);
        Level = NewLvl;             // $B2a5nCM99?7(B
        Display();                  // $B:BI8I=<((B
        NewLvl = ADConv(7);         // $B?7%l%Y%kB,Dj(B
         if(NewLvl > PeakL){        //$B!!:GBgCMHf3S(B
            PeakL = NewLvl;         // $B:GBgCM99?7(B
            PeakH = HWidth;
            PeakV = VWidth;
        }  
    }while(Level < NewLvl);         // $B%T!<%/99?77QB3(B
}

/*************************************
 *  $B0LCV:BI8I=<(%5%V4X?t(B
 *************************************/
/** $BI8=`=PNO4X?tMQDc%l%Y%k4X?tDj5A(B **/
void putch(unsigned char data){
    lcd_data(data);                     // $B1U>=I=<(4o$rI8=`=PNO$H$9$k(B
}
void Display(void){
    lcd_cmd(0xC0);                                  // 2$B9TL\(B
    printf("X%03d Y%03d  V%04d",HWidth, VWidth, Level);
}
/***************************************
*  A/D$BJQ49F~NO4X?t(B
****************************************/
unsigned int ADConv(unsigned char ch){
    int i, j;
    unsigned int value;

    value = 0;
    for(j=0; j<5; j++){                         // 5$B2s$NJ?6Q(B
        ADCON0 = (ch << 2) | 0x01;              // $B%A%c%M%kA*Br(B
        for(i=0; i<40; i++);                    // $B%"%/%$%8%7%g%s%?%$%`BT$A(B
        GO = 1;                                 // $BJQ493+;O(B
        while(GO);                              // $BJQ49=*N;BT$A(B
        value += (ADRESH & 0x0F)*256 + ADRESL;  // $BJQ497k2L7W;;(B
    }
    return(value/5);                            // $BJQ497k2L$rJV$9(B
}
/*************************************
* $B%?%$%^(B0$B3d$j9~$_=hM}4X?t(B
*************************************/
void interrupt isr(void){
    if(TMR0IF){                             // $B%?%$%^(B0$B3d$j9~$_$+!)(B
        TMR0IF = 0;                         // $B%U%i%0%/%j%"(B
        TMR0 = 96;                          // $B;~4V:F@_Dj(B
        Interval--;                         // $B%$%s%?!<%P%k99?7(B
        if(Interval == 0){                  // $B@_Dj;~4V$N>l9g(B
            Interval = 5;                   // 0.1sec$B$K:F%;%C%H(B
            DFlag = 1;                      // $BI=<(%U%i%0%*%s(B          
            AutoInt--;                      // 10sec$B%?%$%^99?7(B
            if(AutoInt == 0){               // 10sec$B$+!)(B
                AutoInt = 300;              // $B%?%$%^:F@_Dj(B30sec
                AutoFlag = 1;               // $B<+F0%b!<%I3+;O%U%i%0%*%s(B
            }
        }
    }
}
/*************************************
* CLC$B=i4|@_Dj4X?t(B
*************************************/
void CLCInit(void){
   /* Timer0$B$N(B20msec$B<~4|$G(BPWM3$B$H(BPWM4$B$N=PNO$r(B1$B2s$N$_M-8z2=(B */
    /* CLC1 $B=i4|@_Dj(B */
    CLC1GLS0 = 0x08;
    CLC1GLS1 = 0x00;                    // RS$B%U%j%C%W%U%m%C%W(B
    CLC1GLS2 = 0x02;                    // Timer0$B$G%;%C%H(B
    CLC1GLS3 = 0x00;                    // Timer2$B$G%j%;%C%H(B
    CLC1SEL0 = 0x17;
    CLC1SEL1 = 0x60;
    CLC1POL  = 0x00;
    CLC1CON  = 0xC3;
    /* CLC2 $B=i4|@_Dj(B */
    CLC2GLS0 = 0x08;
    CLC2GLS1 = 0x20;                    // AND$B2sO)(B
    CLC2GLS2 = 0x00;                    // CLC3$B=PNO$H(BPWM1$B=PNO$N(BAND
    CLC2GLS3 = 0x00;
    CLC2SEL0 = 0x62;
    CLC2SEL1 = 0x66;
    CLC2POL  = 0x0C;
    CLC2CON  = 0xC2;
    /* CLC3 $B=i4|@_Dj(B */
    CLC3GLS0 = 0x02;
    CLC3GLS1 = 0x08;                    // D$B%?%$%W%U%j%C%W%U%m%C%W(B
    CLC3GLS2 = 0x00;                    // CLC1$B$N=PNO$r(BD$BF~NO(B
    CLC3GLS3 = 0x00;                    // Timer2$B$,%/%m%C%/(B
    CLC3SEL0 = 0x47;
    CLC3SEL1 = 0x50;
    CLC3POL  = 0x00;
    CLC3CON  = 0x84;
    /* CLC4 $B=i4|@_Dj(B */
    CLC4GLS0 = 0x08;
    CLC4GLS1 = 0x80;                    // AND$B2sO)(B
    CLC4GLS2 = 0x00;                    // CLC3$B=PNO$H(BPWM4$B=PNO$N(BAND
    CLC4GLS3 = 0x00;
    CLC4SEL0 = 0x62;
    CLC4SEL1 = 0x37;
    CLC4POL  = 0x0C;
    CLC4CON  = 0xC2;
}